<?php

$status = array
(
    1 => '正常',
    2 => '申请退款中',
    3 => '已退款',
);

return array
(
    # 表名
    'name' => 'buy_goods',
    # 显示给用户看的名称
    'lang' => '订单商品表',
    'menu' => false,
    'status' => $status,
    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            //'list'        => true,
        ),

        'order_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '订单表id',
            'default'   => '',
            'desc'      => '订单表id',
            'match'     => 'is_numeric',
        ),

        'seller_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '销售商',
            'default'   => '',
            'desc'      => '销售商',
            'match'     => 'is_numeric',
        ),

        'goods_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '商品名称',
            'default'   => '',
            'desc'      => '商品名称',
            'match'     => 'is_numeric',
        ),

        'sku_id'      => array
        (
            'type'      => 'int-11',
            'name'      => 'sku_id',
            'default'   => '-1',
            'desc'      => 'sku_id',
            'match'     => 'is_numeric',
        ),

        'cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '单价',
            'default'   => '',
            'desc'      => '单价',
            'match'     => 'option',
            'update'    => 'text',
            'list'        => true,
        ),

        'num'        => array
        (
            'type'      => 'int-11',
            'name'      => '购买数量',
            'default'   => '',
            'desc'      => '购买数量',
            'match'     => 'is_numeric',
            'search'    => 'select',
            'list'        => true,
        ),

        'pay_cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '支付金额',
            'default'   => '',
            'desc'      => '支付金额',
            'match'     => 'option',
            'update'    => 'text',
            'list'        => true,
        ),

        'wallet_cash'      => array
        (
            'type'      => 'decimal-11,2',
            'name'      => '钱包抵扣金额',
            'default'   => '0',
            'desc'      => '钱包抵扣金额',
            'match'     => 'option',
            'update'    => 'text',
        ),

        'status'        => array
        (
            'type'      => 'int-11',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '状态',
            'match'     => 'is_numeric',
            //'update'  => 'select',
            'option'    => $status,
            'search'    => 'select',
            'list'      => true,
            'edit'      => true,
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            'insert'    => true,
            'search'    => 'date',
            'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        'insert' => false,
        'delete' => false,
        'page_list' => 'buy_goods',
    ),

    'request' => array
    (
        # 获取总金额
        'getNum' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'start' => array('yes-t_2.cdate', '>='),
                'end' => array('yes-t_2.cdate', '<='),
                'start_o' => array('yes-t_2.operdate', '>='),
                'end_o' => array('yes-t_2.operdate', '<='),
                'shop_id' => array('yes-t_2.shop_id'),
                'goods_id' => array('yes-t_1.goods_id'),
                'status' => array('yes-t_2.status', 'in'),
                'state_2' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
                'status_1' => 'yes-t_1.status-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'shop/sell_order',
                    'type' => 'left join',
                    'on' => array('order_id','id'),
                ),
            ),
            'type' => 'all',
            'group' => 't_2.shop_id, t_1.goods_id',
            'col' => 'id,t_2.shop_id, t_1.goods_id,sum(t_1.price*t_1.num) as cash,sum(t_1.num) as num',
        ),
    ),
);
