<?php

$type = function()
{
	$array = array();
	$data = Dever::load('role/supplier_type-state');
	if($data)
	{
		$array += $data;
	}
	return $array;
};

$category = function()
{
	$array = array();
	$data = Dever::load('product/category-getTop');
	if($data)
	{
		$array += $data;
	}
	return $array;
};

$identity = array
(
	1 => '个人',
	2 => '个体户',
	3 => '企业',
);

return array
(
	# 表名
	'name' => 'supplier',
	# 显示给用户看的名称
	'lang' => '供应商',
	# 是否显示在后台菜单
	'order' => 11,

	# 数据结构
	'struct' => array
	(
		'id' 		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> 'ID',
			'default' 	=> '',
			'desc' 		=> '',
			'match' 	=> 'is_numeric',
			'list'		=> true,
			'order'		=> 'asc',
		),

		'name'		=> array
		(
			'type' 		=> 'varchar-150',
			'name' 		=> '供应商名称',
			'default' 	=> '',
			'desc' 		=> '供应商名称',
			'match' 	=> 'is_string',
			'update'	=> 'text',
			'search'	=> 'fulltext',
			'list'		=> true,
			'edit'		=> true,
		),

		'type_id'        => array
        (
            'type'      => 'int-11',
            'name'      => '供应商类型',
            'default'   => '1',
            'desc'      => '供应商类型',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $type,
        ),

        'category'		=> array
		(
			'type' 		=> 'varchar-2000',
			'name' 		=> '商品属性分类-如不选择就是可以销售所有商品属性分类下的商品',
			'default' 	=> '',
			'desc' 		=> '商品属性分类',
			'match' 	=> 'is_string',
			'update'	=> 'checkbox',
			'option'	=> $category,
		),

		'truename'      => array
        (
            'type'      => 'varchar-100',
            'name'      => '联系人姓名',
            'default'   => '',
            'desc'      => '请输入联系人姓名',
            'match'     => 'is_string',
            'update'    => 'text',
            'search'    => 'fulltext',
            'tab'		=> 1,
        ),

        'mobile'      => array
        (
            'type'      => 'bigint-11',
            'name'      => '联系人电话',
            'default'   => '',
            'desc'      => '请输入联系人电话',
            'match'     => 'is_numeric',
            'update'    => 'text',
            'search'    => 'fulltext',
            'tab'		=> 1,
        ),

        'area'       => array
        (
            'type'      => 'varchar-500',
            'name'      => '联系人城市',
            'default'   => '',
            'desc'      => '联系人城市',
            'match'     => 'option',
            'search'    => 'linkage',
            'update'    => 'linkage',
            'option'    => Dever::url('api.get?level_total=3', 'area'),
            //'list'      => 'Dever::load("area/api.string", "{area}")',
            'tab'		=> 1,
        ),

        'province'      => array
        (
            'type'      => 'int-11',
            'name'      => '省份',
            'default'   => '',
            'desc'      => '省份',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'		=> 1,
        ),

        'city'      => array
        (
            'type'      => 'int-11',
            'name'      => '城市',
            'default'   => '',
            'desc'      => '城市',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'		=> 1,
        ),

        'county'      => array
        (
            'type'      => 'int-11',
            'name'      => '县区',
            'default'   => '',
            'desc'      => '县区',
            'match'     => 'option',
            //'update'  => 'text',
            'tab'		=> 1,
        ),

        'address'       => array
        (
            'type'      => 'varchar-1000',
            'name'      => '联系人地址',
            'default'   => '',
            'desc'      => '联系人地址',
            'match'     => 'option',
            'update'    => 'text',
            //'list'        => true,
            'tab'		=> 1,
        ),

        'identity'        => array
        (
            'type'      => 'tinyint-1',
            'name'      => '销售商身份',
            'default'   => '1',
            'desc'      => '销售商身份',
            'match'     => 'is_numeric',
            'update'    => 'radio',
            'option'    => $identity,
            'control'	=> 'identity',
            'tab'		=> 2,
        ),

        'idcard_front'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '身份证正面-如果是个人，这里上传联系人身份证，如果是个体户或者企业，这里上传法人身份证',
            'default'   => '',
            'desc'      => '身份证正面',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'tab'		=> 2,
        ),

        'idcard_back'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '身份证背面-如果是个人，这里上传联系人身份证，如果是个体户或者企业，这里上传法人身份证',
            'default'   => '',
            'desc'      => '身份证背面',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'tab'		=> 2,
        ),

        'company_name'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '企业名称',
            'default'   => '',
            'desc'      => '企业名称',
            'match'     => 'option',
            'update'    => 'text',
            'show'		=> 'identity=2,3',
            'tab'		=> 2,
        ),

        'company_license'     => array
        (
            'type'      => 'varchar-150',
            'name'      => '企业营业执照',
            'default'   => '',
            'desc'      => '企业营业执照',
            'match'     => 'option',
            'update'    => 'image',
            'key'       => '8',
            'place'     => '660*660',
            'show'		=> 'identity=2,3',
            'tab'		=> 2,
        ),

        'company_license_number'      => array
        (
            'type'      => 'varchar-200',
            'name'      => '企业营业执照号码',
            'default'   => '',
            'desc'      => '营业执照号码',
            'match'     => 'option',
            'update'    => 'text',
            'show'		=> 'identity=2,3',
            'tab'		=> 2,
        ),

		'reorder'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '排序(数值越大越靠前)',
			'default' 	=> '1',
			'desc' 		=> '请输入排序',
			'match' 	=> 'option',
			//'update'	=> 'text',
			'search'	=> 'order',
			'list_name' => '排序',
			'list'		=> true,
			'order'		=> 'desc',
			'edit'		=> true,
		),
		
		'state'		=> array
		(
			'type' 		=> 'tinyint-1',
			'name' 		=> '状态',
			'default' 	=> '1',
			'desc' 		=> '请选择状态',
			'match' 	=> 'is_numeric',
		),
		
		'cdate'		=> array
		(
			'type' 		=> 'int-11',
			'name' 		=> '录入时间',
			'match' 	=> array('is_numeric', time()),
			'desc' 		=> '',
			# 只有insert时才生效
			'insert'	=> true,
			//'search'	=> 'date',
			//'list'		=> 'date("Y-m-d H:i:s", {cdate})',
		),
	),

	'manage' => array
	(
		'tab' => array('基本设置', '联系人信息', '认证信息'),
		'button' => array
        (
            '类型配置' => array('list', 'supplier_type&oper_parent=supplier'),
        ),
        'list_button' => array
        (
        	'location' => array('商品列表', Dever::url('lib/supplier.setGoods', 'role')),
            //'fast_add' => array('账户操作', 'push&project=account&oper_table=supplier&oper_project=role&uid={id}'),
        )
	),

	'default' => array
	(
		'col' => 'name,type_id,state,cdate',
		'value' => array
		(
			'"默认供应商", 1, 1,' . DEVER_TIME,
		),
	),

	'request' => array
	(
		
	)
);
