<?php
$status = Dever::config('base')->status;
return array
(
    # 表名
    'name' => 'supplier_goods',
    # 显示给用户看的名称
    'lang' => '供应商商品列表',
    'order' => 10,
    'menu'  => false,

    /*
    'end' => array
    (
        'insert' => 'role/lib/seller.goodsUpdate',
        'update' => 'role/lib/seller.goodsUpdate',
    ),
    */

    # 数据结构
    'struct' => array
    (
    
        'id'        => array
        (
            'type'      => 'int-11',
            'name'      => 'ID',
            'default'   => '',
            'desc'      => '',
            'match'     => 'is_numeric',
            'search'    => 'order',
            'update'    => 'hidden',
            //'list'        => true,
        ),

        'supplier_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '所属供应商',
            'default'   => '',
            'desc'      => '所属供应商',
            'match'     => 'is_numeric',
            'update'    => 'hidden',
            'search'    => 'hidden',
            'value'     => Dever::input('search_option_supplier_id'),
            'list'      => 'Dever::load("role/supplier-one#name", {supplier_id})',
        ),

        'goods_id'      => array
        (
            'type'      => 'int-11',
            'name'      => '商品名称',
            'default'   => '',
            'desc'      => '商品名称',
            'match'     => 'is_numeric',
            'update'    => 'select',
            'update_search' => 'product/lib/manage.search',
            'list'      => 'Dever::load("product/info-one#name", {goods_id})',
        ),

        'state'     => array
        (
            'type'      => 'tinyint-1',
            'name'      => '状态',
            'default'   => '1',
            'desc'      => '请选择状态',
            'match'     => 'is_numeric',
        ),
        
        'cdate'     => array
        (
            'type'      => 'int-11',
            'name'      => '创建时间',
            'match'     => array('is_numeric', time()),
            'desc'      => '',
            # 只有insert时才生效
            //'insert'    => true,
            //'search'    => 'date',
            //'list'      => 'date("Y-m-d H:i:s", {cdate})',
        ),
    ),

    'manage' => array
    (
        'insert' => false,
        'edit' => false,
        'delete' => false,
    ),

    'request' => array
    (
        'getData' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'supplier_id' => array('yes-t_1.supplier_id'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'col' => '*,t_2.*',
        ),

        'getDataPage' => array
        (
            # 匹配的正则或函数 选填项
            'option' => array
            (
                'supplier_id' => array('yes-t_1.supplier_id'),
                'name' => array('yes-t_2.name', 'like'),
                'category' => array('yes-t_2.category', 'like'),
                'top_category_id' => array('yes-t_2.top_category_id'),
                'second_category_id' => array('yes-t_2.second_category_id'),
                'category_id' => array('yes-t_2.category_id'),
                'status' => 'yes-t_2.status-1',
                'state' => 'yes-t_2.state-1',
                'state_1' => 'yes-t_1.state-1',
            ),
            # 联表
            'join' => array
            (
                array
                (
                    'table' => 'product/info',
                    'type' => 'left join',
                    'on' => array('goods_id','id'),
                    'col' => 'goods_id',
                ),
            ),
            'type' => 'all',
            'order' => array('t_2.reorder' => 'desc', 't_2.id' => 'desc'),
            'page' => array(10, 'list'),
            'col' => '*,t_2.*',
        ),
    ),
);
